"use strict";
const ts = require("typescript");
const fs_1 = require("fs");
const fs_2 = require("fs");
const fileNames = ['index.ts'];
const basePath = process.cwd();
const settings = ts.convertCompilerOptionsFromJson('{}', basePath);
const servicesHost = {
    getScriptFileNames: () => fileNames,
    getScriptVersion: (fileName) => files[fileName] && files[fileName].version.toString(),
    getScriptSnapshot: (fileName) => {
        if (!fs_1.existsSync(fileName)) {
            return undefined;
        }
        return ts.ScriptSnapshot.fromString(fs_2.readFileSync(fileName).toString());
    },
    getCurrentDirectory: () => process.cwd(),
    getCompilationSettings: () => ({ module: ts.ModuleKind.CommonJS }),
    getDefaultLibFileName: (options) => ts.getDefaultLibFilePath(options),
};
const services = ts.createLanguageService(servicesHost, ts.createDocumentRegistry());
const program = ts.createProgram(fileNames, settings.options);
let diagnostics = program.getSyntacticDiagnostics();
const emitOutput = program.emit();
const files = program.getSourceFiles();
debugger;
